<template>
  <div class="node" v-if="nodeLoaded">
    <!-- <pre>{{ currentNode }}</pre> -->
    <editable-zone :register="[{ node: currentNode, path: ['field_links', 0] }]" :title="'Ah'">
      <editable-link :node="currentNode" :path="['field_links', 0]" :style="{ backgroundColor: 'purple' }">
        <editable-textfield :node="currentNode" :path="['field_links', 0, 'text']"></editable-textfield>
      </editable-link>
    </editable-zone>

    <editable-zone :register="[{ node: currentNode, path: ['hero', 'bg_image'] }]" :title="'Image'">
      <!-- <editable-image :node="currentNode" :path="['hero', 'bg_image', 'field_media_image']" :style="{ backgroundColor: 'yellow' }">
        <template slot-scope="{ url }">
          <img :src="url">
        </template>
      </editable-image> -->
      <editable-image :node="currentNode" :path="['hero', 'bg_image', 0, 'field_media_image']" :style="{ backgroundColor: 'yellow' }">
        <template slot-scope="{ image }">
          <img v-if="image.url" :src="image.url" :alt="image.alt">
          <div :style="{ width: '500px', height: '500px', backgroundImage: image.url ? 'url(' + image.url + ')' : '' }"></div>
        </template>
      </editable-image>
    </editable-zone>

    <editable-link :node="currentNode" :path="['field_links', 1]" :style="{ backgroundColor: 'brown' }">
      <template slot-scope="{ link }">
      <!-- {{ link }} -->
<!--       <template slot-scope="{ link: { text, url } }">
        WAAAAAA
        {{ url }} // {{ text }}

        <editable-link :node="currentNode" :path="['field_links', 0]" :style="{ height: '50px', width: '100px', backgroundColor: 'purple' }">
          <template slot-scope="{ link: { text, url } }">
            {{ url }} // {{ text }}
          </template>
        </editable-link>
        ZAAAAAA
      </template>
 -->
      <!-- <template slot="url" slot-scope="{ url }">
        {{ url }}
      </template>
      <template slot="text" slot-scope="{ text }">
        {{ text }}
        <editable-link :node="currentNode" :path="['field_links', 0]" :style="{ height: '100px', width: '200px', backgroundColor: 'purple' }">
          <template slot="url" slot-scope="{ url }">
            {{ url }}
          </template>
          <template slot="text" slot-scope="{ text }">
            {{ text }}
          </template>
        </editable-link>
      </template> -->

        <!-- <router-link :to="{ path: url }"> -->
        <editable-textfield :node="currentNode" :path="['field_links', 1, 'text']" :style="{ backgroundColor: 'blue', width: '200px' }"></editable-textfield>

        <!-- <pre>{{ currentNode.rows }}</pre> -->
        <!-- </router-link> -->
      </template>
    </editable-link>

    <div v-for="(row, index) in currentNode.rows" v-if="row" :key="row.pid || index">
      <component v-if="$options.components[row._type]" :is="row._type" :node="currentNode" :path="[ 'rows', index ]" :title="'Node\'s row #' + (index + 1)"></component>
    </div>

    <!-- <editable-textfield :node="currentNode" :path="['hero', 'title']"></editable-textfield> -->
  </div>
</template>

<script>
// import Vue from 'vue'

// import _ from 'lodash'

import { toTitle } from '@/utils/tools'

// import { mapGetters, mapActions } from 'vuex'

import TextBox from '@/components/Rows/TextBox'

// import NodeByPath from '@/mixins/NodeByPath'

import { NodeByPathMixin } from 'y3ti-i3'

export default {
  mixins: [NodeByPathMixin],

  components: {
    'text_box': TextBox
  },

  props: {
    path: {
      type: String,
      required: true
    },
    isNew: {
      type: Boolean,
      required: false
    }
  },

  metaInfo () {
    return {
      title: toTitle(this.currentNode.title)
    }
  },

  data () {
    return {
      // component: 'text-box'
    }
  },
  // watch: {
  // },
  // computed: {
  //   ...mapGetters({
  //     getNodeByPath: 'Y3TI/getNodeByPath',
  //     editMode: 'Y3TI/editMode',
  //     getEditedNodes: 'Y3TI/getEditedNodes',
  //     getFieldConfig: 'Y3TI/getFieldConfig'
  //     // getFieldConfigStatus: 'Y3TI/getFieldConfigStatus'
  //   }),

  //   originalNode () {
  //     return this.getNodeByPath(this.$route.path)
  //   },

  //   currentNode () {
  //     let node = this.originalNode
  //     if (this.editMode && !_.isEmpty(node)) {
  //       const editedNode = this.getEditedNodes([ node._type, 'nid-' + node.nid ])
  //       if (editedNode) {
  //         node = editedNode
  //       }
  //     }
  //     return node
  //   },

  //   nodeLoaded () {
  //     let check = !_.isEmpty(this.currentNode)
  //     return this.editMode ? check && !_.isEmpty(this.getFieldConfig([ this.currentNode._type ])) : check
  //   }
  // },

  methods: {
    // ...mapActions({
    //   getOneNodeCall: 'Y3TI/getOneNode',
    //   // getFieldsConfigCall: 'Y3TI/getFieldsConfig',
    //   setEditableNodeCall: 'Y3TI/setEditableNode',
    //   setEditableActiveZone: 'Y3TI/setEditableActiveZone'
    // }),

    // async getCurrentNode ({ title, register }) {
    //   await this.getOneNodeCall({ data: { path: this.$route.path }, options: { lazy: false } }).catch((err) => {
    //     console.log(err)
    //   }).then(() => {
    //     if (this.editMode) {
    //       this.setEditableNode(this.originalNode)
    //       this.setEditableActiveZone({ data: { isDefault: true, title, register } })
    //     }
    //   })
    // },

    // // async getFieldsConfig (contentType) {
    // //   await this.getFieldsConfigCall({ data: { contentType }, options: { lazy: true } }).catch((err) => {
    // //     console.log(err)
    // //   })
    // // },

    // async setEditableNode (node, related) {
    //   await this.setEditableNodeCall({ data: { path: this.$route.path, node, related } }).catch((err) => {
    //     console.log(err)
    //   })
    // }
    // async setCurrentContentType (contentType) {
    //   await this.setCurrentContentTypeCall({ data: { contentType }, options: { lazy: false } }).catch((err) => {
    //     console.log(err)
    //   })
    // }

  //   async getAllLandingPages () {
  //     await this.getAllLandingPagesCall({ options: { lazy: true } }).catch((err) => {
  //       console.log(err)
  //     })
  //   },

  //   async getAllHomeSlides () {
  //     await this.getAllHomeSlidesCall({ options: { lazy: true } }).catch((err) => {
  //       console.log(err)
  //     })
  //   }

  },

  created () {
    console.log('aaaa')
    this.getCurrentNode()
    // .then(() => {
    //   if (this.editMode) {
    //     this.setEditableNode(this.originalNode)
    //     this.setEditableActiveZone({ data: { isDefault: true, title: 'Ooooh', register: [{ node: this.currentNode, path: ['field_links', 0] }] } })
    //   }
    // })
    // if (this.editMode) {
    //   this.getFieldsConfig('page')
    // }
    // this.setCurrentContentType('page')
  }
}
</script>

<style lang="scss" scoped>
</style>
